{% extends "ajax/game/town/town.html.twig" %}
{%block title %}{{'Werkstatt'|trans({}, 'game')|raw }}{% endblock %}
{% block content %}
    {% set hour = "now"|date("G") %}
    <div class="row">
        <div class="cell rw-12 town-banner town-banner-workshop time-{{ hour }} {% if conf.isNightTime %}night{% endif %}"></div>
    </div>

    <div class="help">
        {% trans from 'game' %}
            In der Werkstatt können Materialien zu brauchbaren Hilfsmitteln verarbeitet werden, die für bestimmte Gebäude und Konstruktionen in der Stadt notwendig sind.
        {% endtrans %}<br />
        <i class="strong">
            {% trans from 'game' %}
                Alle zu bearbeitenden Gegenstände müssen direkt in der Bank deponiert werden.
            {% endtrans %}
            {% trans with {'{ap}': '<div class="ap">' ~ need_ap ~ '</div>'} from 'game' %}
                Jede Verarbeitung kostet {ap} (manche Gegenstände und Konstruktionen können diese Verarbeitungskosten senken).
            {% endtrans %}
            {% if saw or manu %}
                <p><b>
                    {% if saw  %}{% trans from 'game' %}Du trägst eine Säge bei dir.{% endtrans %}{% endif %}
                    {% if manu %}{% trans from 'game' %}Die Stadt verfügt über eine Manufaktur.{% endtrans %}{% endif %}
                </b></p>
                <p><b></b></p>
            {% endif %}
        </i>
    </div>

    {% if banished %}
        <div class="note note-warning">
            {% trans from 'game' %}
                Du wurdest verbannt und kannst daher nicht länger in der Werkstatt arbeiten.
            {% endtrans %}
        </div>
    {% endif %}

    {% set has_recipes = false %}
    {% for recipe in recipes %}
        {% if source[recipe.id] > 0 %}
            {% set has_recipes = true %}
        {% endif %}
    {% endfor %}

    {% if has_recipes %}
        <div class="note note-critical">
            <img src="{{ asset('build/images/icons/small_warning.gif') }}" alt="" />
            {% trans from 'game' %}
                Achte darauf, keine <strong>nutzlosen Ressourcen</strong> herzustellen! Wenn du dir nicht sicher bist, sieh in dem <strong>Forum</strong> hier unten nach...
            {% endtrans %}
        </div>

        <div class="row-table workshop">
        <div class="row-flex header bottom">
            <div class="padded cell rw-1 hide-mobile hide-lg">
                {% trans from 'game' %}Vorrat{% endtrans %}
            </div>
            <div class="padded cell rw-1 hide-desktop">
                {% trans from 'game' %}Vor.{% endtrans %}
            </div>
            <div class="padded cell rw-7 hide-desktop hide-lg center">
                {% trans from 'game' %}Umwandlung{% endtrans %}
            </div>
            <div class="padded cell rw-3 hide-sm hide-md">
                {% trans from 'game' %}Material{% endtrans %}
            </div>
            <div class="padded cell rw-4 hide-sm hide-md">
                {% trans from 'game' %}Hergestellter Gegenstand{% endtrans %}
            </div>
            <div class="padded cell hide-mobile hide-lg rw-1">
                {% trans from 'game' %}Anzahl{% endtrans %}
            </div>
            <div class="padded cell rw-2 rw-lg-1 hide-desktop">
                {% trans from 'game' %}Anz.{% endtrans %}
            </div>
            <div class="padded cell rw-3 rw-md-2 rw-sm-2 right">
                <span class="hide-md hide-sm">{% trans from 'game' %}Handeln{% endtrans %}</span> (<div class="ap">{{ need_ap }}</div>)
            </div>
        </div>
        {% for recipe in recipes %}
            {# @var recipe \App\Entity\Recipe #}
            {% if source[recipe.id] > 0 %}
                <div class="row-flex recipe">
                    <div class="padded cell rw-2 grow-0 shrink-0">
                        <span class="small">{{ source[recipe.id] }}</span>
                    </div>
                    <div class="padded cell rw-1 grow-0 shrink-0">
                        {% for entry in recipe.source.entries %}
                            {# @var entry \App\Entity\ItemGroupEntry #}
                            <span>
                                    <img src="{{ asset('build/images/item/item_' ~ entry.prototype.icon ~ '.gif') }}" alt="{{ entry.prototype.label|trans({},'items') }}" />
                                    {% if entry.chance > 1 %}
                                        x {{ entry.chance }}
                                    {% endif %}
                                </span>
                        {% endfor %}
                    </div>
                    <div class="padded cell rw-1 grow-0 shrink-0 center">
                        <img src="{{ asset('build/images/icons/small_move.gif') }}" alt="->" />
                    </div>
                    <div class="padded cell rw-4 grow-0 shrink-0 left" style="overflow: hidden">
                        {% if recipe.result.entries|length > 1 %}
                            <span class="small hide-desktop hide-lg">?</span>
                            <span class="small hide-md hide-sm" style="display: block; margin-top: 4px; text-overflow: ellipsis; white-space: nowrap; overflow: hidden">{% trans from 'game' %}Zufälliger Gegenstand{% endtrans %}</span>
                        {% else %}
                            <img class="hide-desktop hide-lg" src="{{ asset('build/images/item/item_' ~ recipe.result.entries[0].prototype.icon ~ '.gif') }}" alt="{{ recipe.result.entries[0].prototype.label|trans({},'items') }}" />
                            <span class="icon hide-md hide-sm" style="display: block; margin-top: 4px; text-overflow: ellipsis; white-space: nowrap; overflow: hidden">
                                    <img style="vertical-align: bottom" src="{{ asset('build/images/item/item_' ~ recipe.result.entries[0].prototype.icon ~ '.gif') }}" alt="{{ recipe.result.entries[0].prototype.label|trans({},'items') }}" />
                                    {{ recipe.result.entries[0].prototype.label|trans({},'items') }}
                                </span>
                        {% endif %}
                    </div>
                    <div class="padded cell rw-1 grow-0 shrink-0">
                        {% if recipe.result.entries|length == 1 %}
                            <span class="small">{{ result[recipe.id] }}</span>
                        {% endif %}
                    </div>
                    <div class="padded cell rw-3 hide-desktop right">
                        <button x-recipe-id="{{ recipe.id }}" class="inline small"><img src="{% if recipe.action == "Zerlegen" %}{{ asset('build/images/item/item_classicKey.gif') }}{% elseif recipe.action == "Öffnen" %}{{ asset('build/images/item/item_can_opener.gif') }}{% else %}{{ asset('build/images/icons/small_refine.gif') }}{% endif %}" alt="" /><span class="hide-lg hide-md hide-sm">{{ recipe.action|trans({},'items') }}</span></button>
                    </div>
                    <div class="padded cell rw-3 hide-mobile">
                        <button x-recipe-id="{{ recipe.id }}"><img src="{% if recipe.action == "Zerlegen" %}{{ asset('build/images/item/item_classicKey.gif') }}{% elseif recipe.action == "Öffnen" %}{{ asset('build/images/item/item_can_opener.gif') }}{% else %}{{ asset('build/images/icons/small_refine.gif') }}{% endif %}" alt="" /><span class="hide-lg hide-md hide-sm">{{ recipe.action|trans({},'items') }}</span></button>
                    </div>
                </div>
            {% endif %}
        {% endfor %}
    </div>
    {% else %}
        <br />
        <div class="row">
            <div class="cell rw-12">
                <div class="note note-lightest">{{ 'Die Bank enthält zur Zeit keine Gegenstände, die bearbeitet werden können...'|trans({},'game') }}</div>
            </div>
        </div>
    {% endif %}

    <h5>{{ 'Diskussionen im Werkstatt-Forum'|trans({},'game') }}</h5>
    <div class="forum-preview-wrapper forum-preview-wrapper-workshop">
        <div class="forum-preview-container">
            <div id="forum-content">
                <div class="center"><i class="fa fa-spin fa-circle-notch"></i> {{ 'Lade Forum...'|trans({},'game') }}</div>
            </div>
        </div>
    </div>

    <div class="row">
        <h5>{{ 'Werkstatt-Register'|trans({},'game') }} <a class="float-right link" x-ajax-href="{{ path("game_newspaper") }}">{{ 'Das Gesamtregister ansehen'|trans({}, 'game') }}<div class="tooltip normal">{{ 'Dieser Link bringt dich zum <strong>Großen Register</strong>. Darin werden alle wichtigen Handlungen und Aktionen der Stadtbürger gespeichert...'|trans({}, 'game')|raw }}</div></a></h5>
        <div class="cell rw-12">
            {% embed "ajax/game/log.html.twig" with {'log_content': log, 'log_source': path('town_workshop_log_controller') } %}
            {% endembed %}
        </div>
    </div>
{% endblock %}
{% block js %}
    {{ parent() }}
    <script>
        {% embed "scripts/log.js.twig" %}{% endembed %}

        let buttons = document.querySelectorAll('[x-recipe-id]');
        for (let i = 0; i < buttons.length; i++)
            buttons[i].addEventListener('click', function() {
                const id = this.getAttribute('x-recipe-id');
                $.ajax.easySend( '{{ path('town_workshop_do_controller') }}', {id: id},
                    function () {
                        $.ajax.load(null, '{{ path('town_workshop') }}', true);
                    } );
            });

        $.ajax.background().no_history().load( document.getElementById('forum-content'), '{{ path('forum_previewer_controller', {fid: town.forum.id, sem: constant('App\\Entity\\Thread::SEMANTIC_WORKSHOP') })|e('js') }}', false, {}, function() {
            let container = document.querySelector('.forum-posts');
            container.scrollTop = container.scrollHeight;
        } );
    </script>
{% endblock %}